/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_OperatorSurfaceCommon_h__
#define __operator_OperatorSurfaceCommon_h__

namespace fe
{

/**************************************************************************//**
    @brief Partial Generic SurfaceI Implemention

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT OperatorSurfaceCommon: virtual public OperatorSurfaceI
{
	public:
						//* As BindI
virtual	void			bind(sp<SignalerI> spSignalerI,sp<Layout> spLayout)
						{
							m_aSurfaceOutput.initialize(spLayout->scope(),
									"SurfaceOutput");
							m_aDrawI.initialize(spLayout->scope(),
									"DrawI");
						}

						//* As OperatorSurfaceCommon
		sp<Component>&	surfaceOutput(Record& a_rSignal)
						{	return m_aSurfaceOutput(a_rSignal); }
		sp<Component>&	drawI(Record& a_rSignal)
						{	return m_aDrawI(a_rSignal); }

	private:
		Accessor< sp<Component> >	m_aSurfaceOutput;
		Accessor< sp<Component> >	m_aDrawI;

	private:
//		sp<DrawI>	m_spDrawI;
};

} // namespace

#endif /* __operator_OperatorSurfaceCommon_h__ */
