/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceAccessibleI_h__
#define __surface_SurfaceAccessibleI_h__

namespace fe
{

class SurfaceAccessorI;

/**************************************************************************//**
	@brief Surface Element Access and Alteration

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceAccessibleI: virtual public Component
{
	public:
		enum	Element
				{
					e_point,
					e_vertex,
					e_primitive,
					e_detail
				};
		enum	Attribute
				{
					e_generic,
					e_position,
					e_normal,
					e_vertices
					// TODO common attributes
				};
								/// @brief Return access to an attribute
virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										String a_name)						=0;
virtual sp<SurfaceAccessorI>	accessor(SurfaceAccessibleI::Element a_element,
										SurfaceAccessibleI::Attribute
										a_attribute)						=0;

								/// @brief Return current underlying SurfaceI
virtual	sp<SurfaceI>			surface(void)								=0;
virtual	sp<SurfaceI>			subSurface(U32 a_subIndex)					=0;

virtual	void					append(sp<SurfaceAccessibleI>
										a_spSurfaceAccessibleI,
										SpatialTransform& a_rTransform)		=0;

virtual	void					instance(sp<SurfaceAccessibleI>
										a_spSurfaceAccessibleI,
										std::vector<SpatialTransform>&
										a_rTransformArray)					=0;

};

} // namespace

#endif /* __surface_SurfaceAccessibleI_h__ */
